/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package battle;

import glgame.models3Dcompilation;

import java.awt.Color;
import java.awt.Font;
import java.awt.GradientPaint;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;

import org.lwjgl.opengl.GL11;

/**
 *
 * @author jub
 * Graphic element.
 */
public class GElement extends Element {

    private Ellipse2D.Float shape = null;
    private Color color = new Color((float) Math.random(), (float) Math.random(), (float) Math.random());

    /**Constructor, creates a graphic circular element.
     * @param position Initial position.
     * @parma size Object radius.
     */
    public GElement(Vector2D position, float size) {
        super(position, size);
        shape = new Ellipse2D.Float((float) getX() - size / 2, (float) getY() - size / 2, size, size);
    }

    /**Returns Object color.*/
    public Color getColor() {
        return color;
    }

    /**Sets object color.
    @param _color Color to be set.
     */
    public void setColor(Color _color) {
        color = _color;
    }

    /**Draws object in screen.
    @param g Graphics2D object.
     */
    public void draw(Graphics2D g) {
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
        g.setPaint(new GradientPaint(
                (float) getX() - size / 2,
                (float) getY() - size / 2,
                Color.darkGray,
                (float) getX() + size / 2,
                (float) getY() + size / 2,
                color));
        g.fill(shape);
        g.setColor(Color.LIGHT_GRAY);
        Font font = new Font("Serif", Font.PLAIN, 12);
        g.setFont(font);
        g.drawString("" + eId, (int) getX(), (int) getY());
    }

    /**Specifies how to draw the 3D model.*/
    public void draw3D() {
        if (size == 20) {
            GL11.glPushMatrix();
            {
                GL11.glTranslatef((float) getX() / 50, 0, (float) getY() / 50);


                GL11.glRotatef((float) -getAngle() + 90, 0, 1, 0);
                //GL11.glRotatef((float)-angleYZ, 1, 0, 0);
                //GL11.glRotatef((float)-angleXZ, 0, 1, 0);
                //GL11.glRotatef((float)-angleXY, 0, 0, 1);
                GL11.glScalef(.2f, .2f, .2f);

                models3Dcompilation.getModels3Dcompilation().render("nave");

            }
            GL11.glPopMatrix();

        } else {
            GL11.glPushMatrix();
            {
                GL11.glTranslatef((float) getX() / 50, 0, (float) getY() / 50);


                GL11.glRotatef((float) -getAngle(), 0, 1, 0);
                //GL11.glRotatef((float)-angleYZ, 1, 0, 0);
                //GL11.glRotatef((float)-angleXZ, 0, 1, 0);
                //GL11.glRotatef((float)-angleXY, 0, 0, 1);
                //GL11.glScalef(.2f,.2f, .2f);

                models3Dcompilation.getModels3Dcompilation().render("bala");

            }
            GL11.glPopMatrix();
        }
    }

    /**Checks if coordinates are contained by object.
    @param x X coordinate to be checked.
     * @param y coordinate to be checked.
     */
    public boolean contains(int x, int y) {
        return shape.getBounds().contains(x, y);
    }

    /**Returns object bounding rectangle.*/
    public Rectangle getBounds() {
        return shape.getBounds();
    }

    /**Deprecated.*/
    @Override
    public void turnRight() {
        super.turnRight();
    }

    /**Deprecated.*/
    @Override
    public void turnLeft() {
        super.turnLeft();
    }

    /**Moves graphical object and logic object forward.*/
    @Override
    public void forward() {
        super.forward();
        shape.setFrame(getX() - size / 2, getY() - size / 2, size, size);
    }

    /**Moves graphical object and logic object back.*/
    @Override
    public void back() {
        super.back();
        shape.setFrame(getX() - size / 2, getY() - size / 2, size, size);
    }
}
