package gldemo;

import java.nio.FloatBuffer;

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.*;
import org.lwjgl.util.glu.*;

import glapp.*;
import glgame.Nave;
import glmodel.*;

public class GLApp_1 extends GLApp{
	
	int texture1 = 0;
	int texture2 = 0;
	
	
	float lightPosition1[]= { 0f, 0f, 0f, 1f };
	
	float rotation=0f;
	
	int sphereDL=0, cubeDL=0;
	
	int cubo=0;
	
	
	//Camaras
	float[] cameraPos = {0f,3f,20f};
	
	
	GLCamera camera1 = new GLCamera();
    GLCamera camera2 = new GLCamera();
    GLCam cam = new GLCam(camera1);
    
    
    //vectores del objeto 3d
    GL_Vector UP = new GL_Vector(0,1,0);
    GL_Vector ORIGIN = new GL_Vector(0,0,0);
	
	
    public GL_Vector mechaPos;
    
    
    GLModel Mecha;
    
    public Nave nave;
    
    FloatBuffer bbmatrix = GLApp.allocFloats(16);
    
	public static void main (String args[]){
		GLApp_1 demo = new GLApp_1();
		demo.window_title = "GLApp Proyecto OO";
        demo.displayWidth = 800;
        demo.displayHeight = 600;
        demo.run();
		
		
	}
	
	public void setup(){
		
		texture1 = makeTexture("/images/marble.jpg");
		
		texture2 = makeTexture("/images/grass_1_512.jpg");
		
		setPerspective();
		
		setLight( GL11.GL_LIGHT1,
        		new float[] { 1.0f, 1.0f, 1.0f, 1.0f },   // diffuse color
        		new float[] { 0.2f, 0.2f, 0.2f, 1.0f },   // ambient
        		new float[] { 1.0f, 1.0f, 1.0f, 1.0f },   // specular
        		lightPosition1 );                         // position
		
		//luz ambiental
		
		setAmbientLight(new float[] { 0.0f, 0.0f, 0.0f, 0.0f });
		
		sphereDL = beginDisplayList();
    	renderSphere();
    	endDisplayList();
    
    	cubeDL = beginDisplayList();
    		renderCube(10,40);
    	endDisplayList();
    	
    	cubo = beginDisplayList();
			renderCube(1,40);
		endDisplayList();
		
		
		// load the airplane model and make it a display list
        mechaPos=new GL_Vector(0,0,-10);
		
        nave = new Nave("nave");
        
		Mecha = new GLModel("/models/SpaceShip/SpaceShip.obj");
        Mecha.mesh.regenerateNormals();
        Mecha.makeDisplayList();
    	
    
    		// enable lighting and texture rendering
    	GL11.glEnable(GL11.GL_LIGHTING);
    	GL11.glEnable(GL11.GL_TEXTURE_2D);

    	// select model view for subsequent transforms
    	GL11.glMatrixMode(GL11.GL_MODELVIEW);
    	GL11.glLoadIdentity();

    	camera1.setCamera(0,4,20, 0,-.3f,-1, 0,1,0);

	}
	
	public static void setPerspective(){
        // select projection matrix (controls perspective)
        GL11.glMatrixMode(GL11.GL_PROJECTION);
        GL11.glLoadIdentity();
        // fovy, aspect ratio, zNear, zFar
        GLU.gluPerspective(30f, aspectRatio, 1f, 100f);
        // return to modelview matrix
        GL11.glMatrixMode(GL11.GL_MODELVIEW);
		
	}
	
	
	public void draw(){
		
		rotation += 25f * getSecondsPerFrame();
		
		//cam.handleNavKeys((float)GLApp.getSecondsPerFrame());
		nave.handleNavKeys((float)GLApp.getSecondsPerFrame());
		//primer paso limpiar
		GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);
		
		// select model view for subsequent transforms
        GL11.glMatrixMode(GL11.GL_MODELVIEW);
        GL11.glLoadIdentity();

        
        
        //camera1.viewDir( nave.getLocationVector().mult(-1) );
        
       
        GL_Vector W = nave.getLocationVector();
        GL_Vector up = nave.getUpVector();
        GL_Vector front = nave.getUpVector();
        GL_Vector cameraPosition = GL_Vector.add(W, GL_Vector.multiply(nave.getFrontVector(), -2));
        
        GL_Vector ViewPoint = GL_Vector.add(cameraPosition, front);
        
        
        //camera2.MoveTo(-W.x+-front.x*3, -W.y-front.y*3, -W.z+-front.z*3);
    	//camera2.viewDir( nave.getFrontVector() );  // point camera in direction of airplane motion
        
        //cam.render();
        // set the viewpoint
        
        GLU.gluLookAt(//0f, 3f, 15f,  // where is the eye
        		cameraPosition.x,cameraPosition.y,cameraPosition.z,
        		//0f, -1f, 0f,    // what point are we looking at
        		//ViewPoint.x, ViewPoint.y, ViewPoint.z,	
        		W.x, W.y, W.z,
        			up.x, up.y, up.z);    // which way is up
        
        
        
        
        // Base
        
        
        //Capacidad de reflexxion del material.
        setMaterial(new float[] {0.0f, 1.0f, 1.0f,1.0f},0.5f);
		
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, texture1);
		
		
		GL11.glPushMatrix();
		{
            
			GL11.glTranslatef(0f, -8f, 0f); // down a bit
			GL11.glRotatef(-45, 0, 1, 0);
			callDisplayList(cubeDL);
        
            
		}
            GL11.glPopMatrix();
		
		/*
		// orbit
		GL11.glTranslatef(3,0,-5);
        GL11.glRotatef(rotation, 0,1,0);
        
                
        setLightPosition( GL11.GL_LIGHT1, lightPosition1 );
        
        setMaterial(
        		new float[] {1.0f, 1.0f, 1.0f, 1.0f},   // diffuse color
        		new float[] {1.0f, 1.0f, 1.0f, 1.0f},   // ambient
        		new float[] {0.0f, 0.0f, 0.0f, 1.0f},   // specular
        		new float[] {1.0f, 1.0f, 1.0f, 1.0f},   // emissive
        		0f);        // not shiny
        
        GL11.glPushMatrix();
        {
            GL11.glScalef(.5f, .5f, .5f);    // make it smaller
            callDisplayList(sphereDL);       // draw the sphere display list
        }
        GL11.glPopMatrix();
		
        GL11.glBindTexture(GL11.GL_TEXTURE_2D, texture2);
        
        GL11.glPushMatrix();
        {
        	
        	GL11.glTranslatef(3,0,0);
            GL11.glRotatef(rotation, rotation,1,0);
            
        	
        	//GL11.glScalef(.5f, .5f, .5f);    // make it smaller
            callDisplayList(cubo);       // draw the sphere display list
        }
        GL11.glPopMatrix();
        
        */
        GL11.glPushMatrix();
        {
        	// place plane at orbit point, and orient it toward origin
        	//billboardPoint(mechaPos, ORIGIN, UP);
        	// turn plane toward direction of motion
            
        	//float aux[]= nave.getLocation();
        	//GL11.glTranslatef(aux[0],aux[1],aux[2] );
        	//GL11.glRotatef(-180, 0, 1, 0);
            // make it big
            //GL11.glScalef(3f, 3f, 3f);
        	nave.render();
        	// reset material, since model.render() will alter current material settings
            setMaterial( new float[] {.8f, .8f, .7f, 1f}, .4f);
        }
        GL11.glPopMatrix();
        
        
	}
	
	public void billboardPoint(GL_Vector bbPos, GL_Vector targetPos, GL_Vector targetUp)
	{
		// direction the billboard will be facing (looking):
		GL_Vector look = GL_Vector.sub(targetPos,bbPos).normalize();
		
		// billboard Right vector is perpendicular to Look and Up (the targets Up vector)
		GL_Vector right = GL_Vector.crossProduct(targetUp,look).normalize();
		
		// billboard Up vector is perpendicular to Look and Right
		GL_Vector up = GL_Vector.crossProduct(look,right).normalize();
		
		// Create a 4x4 matrix that will orient the object at bbPos to face targetPos
		GL_Matrix.createBillboardMatrix(bbmatrix, right, up, look, bbPos);
		
		// apply the billboard matrix
		GL11.glMultMatrix(bbmatrix);
	}
	
    public void keyDown(int keycode) {
    	if (Keyboard.KEY_SPACE == keycode) {
    		cam.setCamera((cam.camera == camera1)? camera2 : camera1);
    	}
    }
}
