package glgame;

import java.nio.FloatBuffer;
import java.awt.Font;
import org.lwjgl.opengl.*;
import org.lwjgl.util.glu.*;
import glapp.*;
import glgame.Nave;
import glmodel.*;

import java.util.ArrayList;

public class GLApp_Navigator extends GLApp{
	
	int texture1 = 0;
	
	float lightPosition1[]= { 1f, 1f, 1f, 1f };
	float values[] = new float[10];
	GL_Vector sphere_center[] = new GL_Vector[10]; 
	int sphereDL[] = new int[10];
	boolean sphere_touch_flag[] = new boolean[10];
	double initial_time = getTimeInSeconds();
	int timeleft = 90;
	int maximum_time = 90;
	int balls_left = 10;
	boolean game_over = false;
	boolean you_win = false;
	
	protected BackGround fondo;
	
	
	// holds a texture mapped font
    GLFont font1;
    GLFont font2;
    GLFont font3;
    GLFont font4;

 // will hold the last seven characters types
    ArrayList lastchars = new ArrayList();
	
	public Game_Camera cam;
    
    public Nave nave;
    
    FloatBuffer bbmatrix = GLApp.allocFloats(16);
    
	public static void main (String args[]){
		GLApp_Navigator demo = new GLApp_Navigator();
		GLApp_Navigator.window_title = "GLApp Proyecto Navigator";
		GLApp_Navigator.displayWidth = 800;
		GLApp_Navigator.displayHeight = 600;
        demo.run();
		
		
	}
	
	public void setup(){
		
		texture1 = makeTexture("/images/marble.jpg");
			
		setPerspective();
		
		setLight( GL11.GL_LIGHT1,
        		new float[] { 1.0f, 1.0f, 1.0f, 1.0f },   // diffuse color
        		new float[] { 1.0f, 1.0f, 1.0f, 1.0f },   // ambient
        		new float[] { .3f, .3f, .3f, .3f },   // specular
        		lightPosition1 );                         // position
		
		//luz ambiental
		
		// Make a font object to render text
		font1 = new GLFont( new Font("Trebuchet", Font.BOLD, 30) );
		font2 = new GLFont( new Font("Trebuchet", Font.BOLD, 18) );
		font3 = new GLFont( new Font("Trebuchet", Font.BOLD, 120) );
		font4 = new GLFont( new Font("Trebuchet", Font.BOLD, 120) );
		
	for(int i=0; i<10 ; i++){
		sphereDL[i] = beginDisplayList();
		sphere_touch_flag[i] = false;
		values[i] = (float)Math.random()*5f;
    		renderSphere();
    	endDisplayList();
	}
    	
   	
		setAmbientLight(new float[] { 0.0f, 0.0f, 0.0f, 0.0f });
			
		fondo = new BackGround("fondo");
       
		
		nave = new Nave("nave");
        
		fondo.setLocation(nave.getLocation());;
    		// enable lighting and texture rendering
    	GL11.glEnable(GL11.GL_LIGHTING);
    	GL11.glEnable(GL11.GL_TEXTURE_2D);

    	// select model view for subsequent transforms
    	GL11.glMatrixMode(GL11.GL_MODELVIEW);
    	GL11.glLoadIdentity();

    	cam=new Game_Camera(nave);

	}
	
	public static void setPerspective(){
        // select projection matrix (controls perspective)
        GL11.glMatrixMode(GL11.GL_PROJECTION);
        GL11.glLoadIdentity();
        // fovy, aspect ratio, zNear, zFar
        GLU.gluPerspective(30f, aspectRatio, 1.1f, 500f);
        // return to modelview matrix
        GL11.glMatrixMode(GL11.GL_MODELVIEW);
		
	}
	
	public void update(){
		/*
		 * Update de todas las naves
		 * 
		 * 
		 */
		if((game_over == false) && (you_win == false)){
				
			if(timeleft == 0)
				game_over = true;
			timeleft = maximum_time - (int)getTime();
			balls_left = NumberOfBalls();
			if(balls_left == 0)
				you_win = true;
			
		}
		
		nave.handleNavKeys((float)GLApp.getSecondsPerFrame());
		fondo.setLocation(nave.getLocation());
	}
	
	
	public void draw(){

		GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);
		
		// select model view for subsequent transforms
        GL11.glMatrixMode(GL11.GL_MODELVIEW);
        GL11.glLoadIdentity();

        cam.setVectors();
        cam.render();
        
        fondo.render();
        
        setMaterial(new float[] {1.0f, 1.0f, 1.0f,1.0f},
        		new float[] {0.0f, 0.0f, 0.0f,1.0f},
        		new float[] {.5f, .5f, .5f,.5f},
        		new float[] {1f, 1f, 1f,1f},
        		0.0f);
		
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, texture1);
		
	for(int i=0; i<10 ; i++){
		GL11.glPushMatrix();
        {
        	sphere_center[i] = new GL_Vector(1f + i*values[i], 1f + i*(float)Math.pow(-1, i), 1f);
        	GL11.glTranslatef(1f + i*values[i], 1f + i*(float)Math.pow(-1, i), 1f);
            GL11.glScalef(.5f,.5f, .5f );    // make it smaller
            if(!sphere_touch_flag[i])
            	callDisplayList(sphereDL[i]);       // draw the sphere display list
        }
        GL11.glPopMatrix();  
	}
	
	if(reseted){
		Reset();
	}
	
	// displays information about the game
	font1.print(40, DM.getHeight()-80, "TIME LEFT: "+timeleft+ " seconds" );
    font2.print( 40,100, "Balls left to win: "+balls_left);
    
    if(game_over == true){
    	font3.print(550,400 , "GAME OVER" );
    	font2.print(600,300 , "Try to be faster next time. Press R key to try again or the ESC key to exit");
    	
    }
    if(you_win == true){
    	font4.print( 650,400, "YOU WIN");
    	font2.print(550,300 , "YOU DID IT!!!!, CONGRATULATIONS. Press R key to play again or the ESC key to exit" );	
    	
    }
		sphereTouch();
        nave.render();
        setMaterial( new float[] {.8f, .8f, .7f, 1f}, .4f);
        
        setLightPosition(GL11.GL_LIGHT1, lightPosition1);
	}
	
	public void billboardPoint(GL_Vector bbPos, GL_Vector targetPos, GL_Vector targetUp)
	{
		// direction the billboard will be facing (looking):
		GL_Vector look = GL_Vector.sub(targetPos,bbPos).normalize();
		
		// billboard Right vector is perpendicular to Look and Up (the targets Up vector)
		GL_Vector right = GL_Vector.crossProduct(targetUp,look).normalize();
		
		// billboard Up vector is perpendicular to Look and Right
		GL_Vector up = GL_Vector.crossProduct(look,right).normalize();
		
		// Create a 4x4 matrix that will orient the object at bbPos to face targetPos
		GL_Matrix.createBillboardMatrix(bbmatrix, right, up, look, bbPos);
		
		// apply the billboard matrix
		GL11.glMultMatrix(bbmatrix);
	}
	
	
	public void sphereTouch(){
		
		GL_Vector ship_position = nave.getLocationVector();
		
		for(int i=0; i<10; i++){
			if (sphere_center[i].sub(ship_position).length() < 1 ){
				sphere_touch_flag[i] = true;
			}
				
		}	
		
	}
	
	public int NumberOfBalls(){
		
		int number_of_balls = 0;
		
		for(int i=0 ; i<10 ; i++){
			if(sphere_touch_flag[i] == false)
				number_of_balls++;
		}
	return number_of_balls;
	}
	
	public double getTime(){
		
		double current_time;
	
		current_time = getTimeInSeconds();
	
	return (current_time - initial_time);
	}
	
	
	public void YouWin(){
		you_win = true;
	}
	
	public void Reset(){
		reseted = false;
		game_over = false;
		you_win = false;
		initial_time = getTimeInSeconds();
		balls_left = 10;
		nave.setLocation(0, 0, 0);
		for(int i=0; i<10; i++){
			sphere_touch_flag[i] = false;
		}
	}
	
}