package glgame;

import java.nio.FloatBuffer;
import java.util.ArrayList;

import javax.swing.JFrame;

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.*;
import org.lwjgl.util.glu.*;

import battle.Element;
import battle.GElement;
import battle.MainFrame;
import javax.swing.JFrame;

import glapp.*;

public class GLApp_SpaceBattle extends GLApp{
	
	int texture1 = 0;
	
	float lightPosition1[]= { 1f, 1f, 1f, 1f };
	
	int sphereDL;
	int cubeDL;
	
	public Game_Camera cam;
    
    public Nave nave;
    
    protected BackGround fondo;
    protected Compass compass;
    
    protected MainFrame mainFrame;
    
    
    FloatBuffer bbmatrix = GLApp.allocFloats(16);
    
	public static void main (String args[]){
		GLApp_SpaceBattle demo = new GLApp_SpaceBattle();
		demo.window_title = "GLApp Proyecto Navigator";
        demo.displayWidth = 800;
        demo.displayHeight = 600;
        demo.run();
		
		
	}
	
	/**
	 * 
	 * No es recomendable editar el constructor de GlApp, por lo tanto ingresamos todas las condiciones iniciales en setup()
	 */
	
	public void setup(){
		
		mainFrame = new MainFrame();
	    mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	    mainFrame.setVisible(true);
		
			
		setPerspective();
		
		setLight( GL11.GL_LIGHT1,
        		new float[] { 1.0f, 1.0f, 1.0f, 1.0f },   // diffuse color
        		new float[] { 0.0f, 0.0f, 0.0f, 1.0f },   // ambient
        		new float[] { .3f, .3f, .3f, .3f },   // specular
        		lightPosition1 );                         // position
		
		//luz ambiental
		
		setAmbientLight(new float[] { 0.0f, 0.0f, 0.0f, 0.0f });
		
		fondo = new BackGround("fondo");
		
        nave = new Nave("nave");
        
        fondo.setLocation(nave.getLocation());
        
        compass=new Compass("compass");
        
        compass.setEntitie(nave);
        compass.setPosition();
        
    		// enable lighting and texture rendering
    	GL11.glEnable(GL11.GL_LIGHTING);
    	GL11.glEnable(GL11.GL_TEXTURE_2D);

    	// select model view for subsequent transforms
    	GL11.glMatrixMode(GL11.GL_MODELVIEW);
    	GL11.glLoadIdentity();

    	cam=new Game_Camera(nave);

	}
	
	
	/**
	 * 
	 * Con esta funcion ejecutada en setup, logramos definir la caracteristicas del frame.
	 */
	public static void setPerspective(){
        // select projection matrix (controls perspective)
        GL11.glMatrixMode(GL11.GL_PROJECTION);
        GL11.glLoadIdentity();
        // fovy, aspect ratio, zNear, zFar
        GLU.gluPerspective(30f, aspectRatio, 1.1f, 500f);
        // return to modelview matrix
        GL11.glMatrixMode(GL11.GL_MODELVIEW);
		
	}
	
	/**
	 * 
	 * El motor de GlApp hara un analisis de frames por segundo primero, luego continuara un update y un draw.
	 */
	public void update(){
		/*
		 * Update de todas las naves
		 * 
		 * 
		 */
		nave.handleNavKeys((float)GLApp.getSecondsPerFrame());
		mainFrame.update((float)GLApp.getSecondsPerFrame());
		
		fondo.setLocation(nave.getLocation());
		compass.setPosition();
	}
	
	
	/**
	 * 
	 * El fin del ciclo, aqui practicamente se deben crear todas las instancia para renderiar
	 */
	public void draw(){

		GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);
		
		// select model view for subsequent transforms
        GL11.glMatrixMode(GL11.GL_MODELVIEW);
        GL11.glLoadIdentity();

        cam.setVectors();
        cam.render();
        
        fondo.render();
        
        setMaterial(new float[] {1.0f, 1.0f, 1.0f,1.0f},
        		new float[] {0.0f, 0.0f, 0.0f,1.0f},
        		new float[] {.5f, .5f, .5f,.5f},
        		new float[] {1f, 1f, 1f,1f},
        		0.0f);
		
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, texture1);
		
		ArrayList<Element> GrupoDeNaves=mainFrame.getElement();
		
		for(Element i:GrupoDeNaves){
			if (i instanceof GElement) {
                GElement s = (GElement) i;
                s.draw3D();
            }
		}
        
        nave.render();
        compass.render();
        
        setMaterial( new float[] {.8f, .8f, .7f, 1f}, .4f);
        
        setLightPosition(GL11.GL_LIGHT1, lightPosition1);
	}

}