package glgame;

import org.lwjgl.util.glu.GLU;
import glmodel.GL_Vector;

public class Game_Camera {

	private GL_Vector Position; 
	private GL_Vector Up;
	private GL_Vector ViewPoint;
	
	private Nave nave;
	/**
	 * 
	 * @param n Objeto nave que la camara siguira
	 */
	public Game_Camera(Nave n){
		nave = n;
		setVectors();
	}
	
	/**
	 * Calibrar la camara
	 */
	public void setVectors(){
		ViewPoint = nave.getLocationVector();
		Position = GL_Vector.add(ViewPoint, GL_Vector.multiply(nave.getFrontVector(), -2));
		Up = nave.getUpVector();
	}
	
	/**
	 * calibra el frame 3D respecto los parametros de la camara
	 */
	public void render(){
		 GLU.gluLookAt(
	        		Position.x,Position.y,Position.z,
	        		ViewPoint.x, ViewPoint.y, ViewPoint.z,
	        		Up.x, Up.y, Up.z);  
	}
}
